<?php
/*
Plugin Name: HANA-XML-STAT 
Plugin URI: http://www.neox.net/w/2007/05/01/hana-xml-stat/ 
Description: Create a XML data feed for your WordPress Blog's  Moderation , Spam , and general posting status data. Works with WP 2.3. This can be used as feed for other Ajax scripts or Yahoo! Widgets. 
Version: 0.4
Author: HanaDaddy
Author URI: http://www.neox.net
*/


if( ! function_exists('get_option')){
	
	exit();
}

$default_options = array(
	'allow_login'=> 0,	//allow all users 0 , only loggin 1
	'show_akismet'=> 1, //akismet total spam block
	'show_modspam'=> 1, //show spam in moderation
	'show_modcom'=> 1	// show comment moderation

);

$changed=0;
if ( isset($_POST['allow_login']) ) {
	$xmlstat_options['allow_login'] = $_POST['allow_login'];
	$changed++;
}

if ( isset($_POST['show_akismet']) ) {
	$xmlstat_options['show_akismet'] = $_POST['show_akismet'];
	$changed++;
}
if ( isset($_POST['show_modspam']) ) {
        $xmlstat_options['show_modspam'] = $_POST['show_modspam'];
        $changed++;
}
if ( isset($_POST['show_modcom']) ) {
	$xmlstat_options['show_modcom'] = $_POST['show_modcom'];
	$changed++;
}

if ($changed > 0){
	update_option('xmlstat_options',$xmlstat_options);
	$show_result="Settings are updated";
}

$xmlstat_options = get_option('xmlstat_options');
						
function xmlstat_options_page() {

global $show_result, $xmlstat_options, $_POST;
if (!$xmlstat_options) {
 	$xmlstat_options = $default_options;	
}
if ( $show_result != '' ) 
	print '<div id="message" class="updated fade"><p>' . $show_result . '</p></div>';
?>
<div class="wrap">
	<h2>Configuration for HANA XML STAT</h2>
	<p> Getting Moderation , Spam , and general posting status data in XML format. This can be used as data feed for other Ajax scripts or Yahoo! Widgets.
	</p>
	<form action="" method="post">
	<fieldset  class="options">
	<table id="optiontable" class="editform">
		<tr>
			<th valign="top">Login is required:</th>
			<td><select name="allow_login">
			<option value="0" <?php if ($xmlstat_options['allow_login'] == 0 ) print "selected"; ?> >No</option>
			<option value="1" <?php if ($xmlstat_options['allow_login'] == 1 ) print "selected"; ?> >Yes</option>
			</select>
			<div>If 'Yes', only Login user is allowed to see the status data.</div></td>
		</tr>
		<tr>
			<th valign="top">Show Akistmet Spam Total #:</th>
			<td><select name="show_akismet">
			<option value="0" <?php if ($xmlstat_options['show_akismet'] == 0 ) print "selected" ?> >No</option>
			<option value="1" <?php if ($xmlstat_options['show_akismet'] == 1 ) print "selected" ?> >Yes</option>
			</select>
			</td>
		</tr>
		<tr>
			<th valign="top">Show # Spam in Moderation:</th>
			<td><select name="show_modspam">
			<option value="0" <?php if ($xmlstat_options['show_modspam'] == 0 ) print "selected" ?> >No</option>
			<option value="1" <?php if ($xmlstat_options['show_modspam'] == 1 ) print "selected" ?> >Yes</option>
			</select>
			</td>
		</tr>
		<tr>
			<th valign="top">Show # Comments in Moderation:</th>
			<td><select name="show_modcom">
			<option value="0" <?php if ($xmlstat_options['show_modcom'] == 0 ) print "selected" ?> >No</option>
			<option value="1" <?php if ($xmlstat_options['show_modcom'] == 1 ) print "selected" ?> >Yes</option>
			</select>
			</td>
		</tr>
	</table>
	<p class="submit"><input name="submit" value="Update Options &raquo;" type="submit"></p>
	</fieldset>
	</form>

<div>The XML feed url is <strong><?php bloginfo("url"); ?>/wp-content/plugins/hana-xml-stat/feed.php</strong></div>

</div>

<?php
}


function xmlstat_admin_menu() {
	if ( function_exists('add_options_page') ) {
		add_options_page('HANA XML STAT Configuration Page','Hana-XML-Stat', 1, __FILE__,'xmlstat_options_page');
	}
}

add_action('admin_menu', 'xmlstat_admin_menu');

// other functions --------------------

if (!$xmlstat_options) {
        $xmlstat_options = $default_options;
}

function xmlstat_allow(){
	global $xmlstat_options; 

	$user = wp_get_current_user();
	//print_r($xmlstat_options);	
	if ($xmlstat_options['allow_login']== 0 ){
		return true;
	}else{
		//Allowed only loggined user
		if ($user->ID == 0 )
			return false;
		else	
			return true;
	}
}


function xmlstat_get_value($key,$arg=""){
	global $wpdb,$wp_version;

	if ($key=='akismet'){
		return get_option('akismet_spam_count');	
	}else
	if ($key=='modspam'){
        	if ( function_exists('akismet_spam_count')){
                        return akismet_spam_count() ;
                }else
                        return -1;
	}else
	if ($key=='modcom'){
		$rval= $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->comments WHERE comment_approved = '0'");
		return $rval;
        }else
	if ($key=='numposts'){
		$rval = $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->posts WHERE post_type = 'post' AND post_status = 'publish'");
		return $rval;	
	}else
        if ($key=='numcomms'){
		$rval=$wpdb->get_var("SELECT COUNT(*) FROM $wpdb->comments WHERE comment_approved = '1'");
		return $rval;	
	}else
        if ($key=='numcats'){
		if ( $wp_version < 2.3 ) {
			$rval=$wpdb->get_var("SELECT COUNT(*) FROM $wpdb->categories");	
		}else{
			$rval= wp_count_terms('category');
		}
		return $rval;
	
	}else{
		return -1;
	}

}

function xmlstat_get_today_stamp($diff=-100){
	
        //TODAY's starting timestamp in Local timezone
	if ($diff == -100) {
		$diff = get_option('gmt_offset');	
	}

        //get gmt
        $a=explode(":",gmdate("G:i:s:m:d:Y"));
        $gstamp= mktime($a[0],0,0,$a[3],$a[4],$a[5]);
        $lstamp = $gstamp + ($diff * 3600);
        //echo "t:".date("F j, Y, H:i a\n",$lstamp);
        $ar= localtime($lstamp);
        //Get the starting timestamp of today.
        $final = mktime(0,0,0,$ar[4]+1,$ar[3],1900 + $ar[5]);
        return $final;
}

function xmlstat_get_slimstat_table(){
        global $table_prefix;
        $table="";
	
        if ( class_exists('wp_shortstat')){
                $table = $table_prefix . "ss_stats";
        }else
	// wp-slimstat 0.92
	if ( class_exists('wp_slimstat') ){
		$tobj = new wp_slimstat();
		if ($tobj) { $table=$tobj->table_stats; $tobj=null; }
		if ( $table == "" ) $table = $table_prefix . "ss_stats";
		
        }else
	if ( class_exists('wp_slimstat_ex')){
                $table = $table_prefix . "slimex_stats";
        }
	return $table;
}

function xmlstat_get_slimstat_hits($table, $option,$ts){
	global $wpdb;

	$sql="";
	if ($table == "") return -1;
	
	if ($option =='all'){
	 	$sql = "select count(*) from $table";
	}else 
	if ($option =='today'){
	 	$sql = "select count(*) from $table where dt >= $ts";
	}else
	if ($option == 'yesterday'){
		$ts1 = $ts - ( 24 * 3600 ) ;
	 	$sql = "select count(*) from $table where dt >= $ts1 and dt < $ts ";
	}else
	if ($option == 'last7'){
		$ts1 = $ts - ( 24 * 3600 * 6);
	 	$sql = "select count(*) from $table where dt >= $ts1";
	}
	
	if ($sql != "" ){
		$rval = $wpdb->get_var($sql);
                return $rval;
	}else{
		return -1;
	}
}


function xmlstat_get_slimstat_uhits($table, $option,$ts){
	global $wpdb;

	$sql="";
	if ($table == "") return -1;
	
	if ($option =='all'){
	 	$sql = "select count(distinct remote_ip) from $table";
	}else 
	if ($option =='today'){
	 	$sql = "select count(distinct remote_ip) from $table where dt >= $ts";
	}else
	if ($option == 'yesterday'){
		$ts1 = $ts - ( 24 * 3600 ) ;
	 	$sql = "select count(distinct remote_ip) from $table where dt >= $ts1 and dt < $ts ";
	}else
	if ($option == 'last7'){
		$ts1 = $ts - ( 24 * 3600 * 6);
	 	$sql = "select count(distinct remote_ip) from $table where dt >= $ts1";
	}
	
	if ($sql != "" ){
		$rval = $wpdb->get_var($sql);
                return $rval;
	}else{
		return -1;
	}
}

function hana_xml_stat_side($prefix="",$postfix="") {
 	global $xmlstat_options;
		
	if ( ! xmlstat_allow())
        	return;

	$base=get_bloginfo("wpurl");
	
	if ($xmlstat_options['show_akismet'] == 1) {
        print $prefix . number_format(xmlstat_get_value('akismet')) . " spam caught by Akismet.$postfix\n";
	}
	
	if ($xmlstat_options['show_modspam'] == 1){
	$link = "$base/wp-admin/edit-comments.php?page=akismet-admin";
	$modspam =xmlstat_get_value('modspam');
	if ($modspam > 0 ){
		$pren="<strong><a href='$link'>"; $postn="</a></strong>";
	}else{
		$pren=""; $postn="";
	}

	print $prefix .$pren. number_format($modspam) . " spams in moderation.$postn$postfix\n";
	}

	if ($xmlstat_options['show_modcom'] == 1){

	$link = "$base/wp-admin/moderation.php";	
	$modcom = xmlstat_get_value('modcom');
	if ($modcom > 0 ){
		$pren="<strong><a href='$link'>"; $postn="</a></strong>";
	}else{
		$pren=""; $postn="";
	}

	print $prefix  . $pren . number_format($modcom) . " comments in moderation.$postn$postfix\n";
	}

	$numposts = number_format(xmlstat_get_value('numposts'));
	$numcomms = number_format(xmlstat_get_value('numcomms'));
	$numcats = number_format(xmlstat_get_value('numcats'));
	print $prefix."$numposts articles, $numcomms comments, and $numcats categories.$postfix\n";

	$table = xmlstat_get_slimstat_table();
	if ($table != ""){
		$ts = xmlstat_get_today_stamp();
		/* $hitt=xmlstat_get_slimstat_hits($table,'today',$ts);
		$hity=xmlstat_get_slimstat_hits($table,'yesterday',$ts);
		if($hitt >-1 && $hity > -1){
			print $prefix."Total hits. Today: $hitt, Yesterday : $hity.$postfix\n";
		}*/
		$uhitt = xmlstat_get_slimstat_uhits($table,'today',$ts);
		$uhity = xmlstat_get_slimstat_uhits($table,'yesterday',$ts);
		if($uhitt >-1 && $uhity > -1){
                        print $prefix."Unique hits. Today: $uhitt, Yesterday: $uhity.$postfix\n";
                }

	}

}

?>
